/*
 ini.h
*/

/* ---- constants */

enum
{ /* values -1 to -255 are pascal string sizes */
	_int8		= -256,
	_int16		= -257,
	_int32		= -258,
	_int64		= -259,

	_uint8		= -260,
	_uint16		= -261,
	_uint32		= -262,
	_uint64		= -263,

	_bool		= -264,	/* non-zero byte */
	_ufrc16		= -265,	/* 0:16 unsigned */
	_ifixed		= -266,	/* 16:16 signed */
	_ufixed		= -267,	/* 16:16 unsigned */

	_ifract		= -268,	/* 2:30 signed */
	_ufract		= -269,	/* 2:30 signed */
	_float		= -270,	/* IEEE 32-bit */
	_double		= -271	/* IEEE 64-bit */
};

/* ---- typedefs */

/* text object */
typedef struct tobj
{ /* NULL str = identifier; otherwise, bit #31 = not allocated */
	long		z;
	char		*s;
} tobj;

/* record object */
typedef struct robj
{
	long		z;
	char		*s;
	void		*p;
} robj;

/* context structure */
typedef struct tcon
{
	robj		*d;
	char		*s;
} tcon;

/* ---- prototypes */

int deltobj(tobj *o);

robj *getrobj(const tcon *l,
	const tobj *o);
int setrobj(robj *l,
	const tobj *d,
	const tobj *s);
int print_robj(struct FILE *f,
	const robj *l);

long read_ini(struct FILE *f,
	const tcon *cl);
void dump_ini(struct FILE *f,
	const tcon *l);
